import './index.css';
import { openBlock as d, createElementBlock as h, withModifiers as x, normalizeClass as P, createCommentVNode as b, toDisplayString as j, isReactive as We, isRef as Ve, resolveComponent as de, createElementVNode as L, createTextVNode as ve, Fragment as Ke, renderList as Ge, createBlock as he, defineComponent as Xe, normalizeStyle as qe } from "vue";
const pe = (e, t) => {
  const s = e.__vccOpts || e;
  for (const [o, i] of t)
    s[o] = i;
  return s;
}, Je = {
  name: "NodePrimitive",
  inheritAttrs: !1,
  emits: ["openParent", "show", "focus"],
  props: [
    // ref
    "root",
    "rootId",
    // options
    "modelValue",
    "name",
    "escapeQuotes",
    "save",
    "saveFocus",
    "focus",
    "delimiter",
    // helpers
    "parentOpen",
    "pointer",
    "type",
    "parentType",
    "size",
    "position",
    "expanded",
    // functions
    "escapeQuotesFn",
    "emitFn"
  ],
  data() {
    return {
      id: this.makeId(),
      hover: !1
    };
  },
  methods: {
    showEmit() {
      return this.emit("show", {
        pointer: this.pointer,
        pointerElement: this.$refs.focusElement,
        type: "primitive"
      }), !0;
    },
    focusEmit() {
      this.emit("focus", {
        pointer: this.pointer,
        focusElement: this.$refs.focusElement
      });
    },
    emit(e, ...t) {
      this.emitFn(this, e, ...t);
    },
    makeId() {
      const e = this.pointer !== "" ? `${this.delimiter}${this.pointer}` : "";
      return `_${this.rootId}${e}`;
    }
  },
  mounted() {
    this.showEmit();
  },
  computed: {
    parentIsArray() {
      return this.parentType === "array";
    },
    nameString() {
      return String(this.name);
    },
    showName() {
      return !this.parentIsArray && this.nameString || this.parentIsArray && this.parentOpen;
    },
    shouldComma() {
      return this.size && this.position && this.position !== this.size;
    },
    isFocused() {
      return String(this.pointer) === String(this.focus);
    }
  }
}, Ye = ["id"], $e = {
  key: 2,
  class: "vue-dd-colon"
}, et = {
  key: 3,
  class: "vue-dd-null"
}, tt = {
  key: 4,
  class: "vue-dd-undefined"
}, nt = {
  key: 5,
  class: "vue-dd-number"
}, st = {
  key: 6,
  class: "vue-dd-bigint"
}, it = {
  key: 7,
  class: "vue-dd-string"
}, rt = {
  key: 9,
  class: "vue-dd-symbol"
}, ot = {
  key: 10,
  class: "vue-dd-unknown"
}, at = {
  key: 11,
  class: "vue-dd-comma"
};
function lt(e, t, s, o, i, n) {
  return d(), h("span", {
    id: i.id,
    class: "vue-dd-primitive",
    onClick: t[4] || (t[4] = x((a) => e.$emit("openParent"), ["prevent"]))
  }, [
    s.parentOpen && s.saveFocus ? (d(), h("span", {
      key: 0,
      ref: "focusElement",
      class: P(["vue-dd-focus vue-dd-icon-eye", {
        "vue-dd-focus-hover": i.hover,
        "vue-dd-focus-selected": n.isFocused
      }]),
      onClick: t[0] || (t[0] = x((...a) => n.focusEmit && n.focusEmit(...a), ["prevent"])),
      onMouseenter: t[1] || (t[1] = (a) => i.hover = !0),
      onMouseup: t[2] || (t[2] = (a) => i.hover = !1),
      onMouseleave: t[3] || (t[3] = (a) => i.hover = !1)
    }, null, 34)) : b("", !0),
    n.showName ? (d(), h("span", {
      key: 1,
      class: P({
        "vue-dd-key": !0,
        "vue-dd-key-of-array": n.parentIsArray
      })
    }, j(s.name), 3)) : b("", !0),
    n.showName ? (d(), h("span", $e, ":")) : b("", !0),
    s.type === "null" ? (d(), h("span", et, "null")) : s.type === "undefined" ? (d(), h("span", tt, "undefined")) : s.type === "number" ? (d(), h("span", nt, j(s.modelValue), 1)) : s.type === "bigint" ? (d(), h("span", st, j(s.modelValue), 1)) : s.type === "string" ? (d(), h("span", it, '"' + j(s.escapeQuotesFn(s.modelValue)) + '"', 1)) : s.type === "boolean" ? (d(), h("span", {
      key: 8,
      class: P(["vue-dd-boolean", { "vue-dd-false": !s.modelValue }])
    }, j(s.modelValue), 3)) : s.type === "symbol" ? (d(), h("span", rt, j(s.modelValue.toString()), 1)) : (d(), h("span", ot, "[unknown_type]" + j(s.modelValue), 1)),
    n.shouldComma ? (d(), h("span", at, ",")) : b("", !0)
  ], 8, Ye);
}
const ze = /* @__PURE__ */ pe(Je, [["render", lt]]);
function ct(e) {
  let t = 0;
  for (let s = 0, o = e.length; s < o; s++) {
    let i = e.charCodeAt(s);
    t = (t << 5) - t + i, t |= 0;
  }
  return t;
}
function Ie(e) {
  return e && typeof e == "object" && !Array.isArray(e);
}
function ut(e) {
  return e !== null && typeof e == "object" && typeof e.then == "function" && typeof e.catch == "function";
}
function dt(e, t, s) {
  if (e !== "")
    return e;
  {
    const o = ht(s);
    return `${t}_${o}`;
  }
}
function ht(e) {
  const t = e.location.hash && typeof e.location.hash[1] < "u" && e.location.hash[1] === "/";
  let s = "";
  if (t)
    s = e.location.href.toString();
  else {
    const o = new URL(e.location.href);
    o.hash = "", s = o.toString();
  }
  return ct(s).toString(16).replace("-", "_");
}
function Ne(e, t = 0) {
  setTimeout(() => {
    window.requestAnimationFrame(() => window.requestAnimationFrame(e));
  }, t);
}
/*!
  Highlight.js v11.7.0 (git: 82688fad18)
  (c) 2006-2022 undefined and other contributors
  License: BSD-3-Clause
 */
var Oe = { exports: {} };
function ke(e) {
  return e instanceof Map ? e.clear = e.delete = e.set = () => {
    throw Error("map is read-only");
  } : e instanceof Set && (e.add = e.clear = e.delete = () => {
    throw Error("set is read-only");
  }), Object.freeze(e), Object.getOwnPropertyNames(e).forEach((t) => {
    var s = e[t];
    typeof s != "object" || Object.isFrozen(s) || ke(s);
  }), e;
}
Oe.exports = ke, Oe.exports.default = ke;
class xe {
  constructor(t) {
    t.data === void 0 && (t.data = {}), this.data = t.data, this.isMatchIgnored = !1;
  }
  ignoreMatch() {
    this.isMatchIgnored = !0;
  }
}
function He(e) {
  return e.replace(/&/g, "&amp;").replace(/</g, "&lt;").replace(/>/g, "&gt;").replace(/"/g, "&quot;").replace(/'/g, "&#x27;");
}
function U(e, ...t) {
  const s = /* @__PURE__ */ Object.create(null);
  for (const o in e)
    s[o] = e[o];
  return t.forEach((o) => {
    for (const i in o)
      s[i] = o[i];
  }), s;
}
const Te = (e) => !!e.scope || e.sublanguage && e.language;
class pt {
  constructor(t, s) {
    this.buffer = "", this.classPrefix = s.classPrefix, t.walk(this);
  }
  addText(t) {
    this.buffer += He(t);
  }
  openNode(t) {
    if (!Te(t))
      return;
    let s = "";
    s = t.sublanguage ? "language-" + t.language : ((o, { prefix: i }) => {
      if (o.includes(".")) {
        const n = o.split(".");
        return [`${i}${n.shift()}`, ...n.map((a, l) => `${a}${"_".repeat(l + 1)}`)].join(" ");
      }
      return `${i}${o}`;
    })(t.scope, { prefix: this.classPrefix }), this.span(s);
  }
  closeNode(t) {
    Te(t) && (this.buffer += "</span>");
  }
  value() {
    return this.buffer;
  }
  span(t) {
    this.buffer += `<span class="${t}">`;
  }
}
const Me = (e = {}) => {
  const t = { children: [] };
  return Object.assign(t, e), t;
};
class _e {
  constructor() {
    this.rootNode = Me(), this.stack = [this.rootNode];
  }
  get top() {
    return this.stack[this.stack.length - 1];
  }
  get root() {
    return this.rootNode;
  }
  add(t) {
    this.top.children.push(t);
  }
  openNode(t) {
    const s = Me({ scope: t });
    this.add(s), this.stack.push(s);
  }
  closeNode() {
    if (this.stack.length > 1)
      return this.stack.pop();
  }
  closeAllNodes() {
    for (; this.closeNode(); )
      ;
  }
  toJSON() {
    return JSON.stringify(this.rootNode, null, 4);
  }
  walk(t) {
    return this.constructor._walk(t, this.rootNode);
  }
  static _walk(t, s) {
    return typeof s == "string" ? t.addText(s) : s.children && (t.openNode(s), s.children.forEach((o) => this._walk(t, o)), t.closeNode(s)), t;
  }
  static _collapse(t) {
    typeof t != "string" && t.children && (t.children.every((s) => typeof s == "string") ? t.children = [t.children.join("")] : t.children.forEach((s) => {
      _e._collapse(s);
    }));
  }
}
class gt extends _e {
  constructor(t) {
    super(), this.options = t;
  }
  addKeyword(t, s) {
    t !== "" && (this.openNode(s), this.addText(t), this.closeNode());
  }
  addText(t) {
    t !== "" && this.add(t);
  }
  addSublanguage(t, s) {
    const o = t.root;
    o.sublanguage = !0, o.language = s, this.add(o);
  }
  toHTML() {
    return new pt(this, this.options).value();
  }
  finalize() {
    return !0;
  }
}
function oe(e) {
  return e ? typeof e == "string" ? e : e.source : null;
}
function De(e) {
  return Y("(?=", e, ")");
}
function ft(e) {
  return Y("(?:", e, ")*");
}
function mt(e) {
  return Y("(?:", e, ")?");
}
function Y(...e) {
  return e.map((t) => oe(t)).join("");
}
function Ae(...e) {
  return "(" + (((s) => {
    const o = s[s.length - 1];
    return typeof o == "object" && o.constructor === Object ? (s.splice(s.length - 1, 1), o) : {};
  })(e).capture ? "" : "?:") + e.map((s) => oe(s)).join("|") + ")";
}
function Qe(e) {
  return RegExp(e.toString() + "|").exec("").length - 1;
}
const yt = /\[(?:[^\\\]]|\\.)*\]|\(\??|\\([1-9][0-9]*)|\\./;
function Ee(e, { joinWith: t }) {
  let s = 0;
  return e.map((o) => {
    s += 1;
    const i = s;
    let n = oe(o), a = "";
    for (; n.length > 0; ) {
      const l = yt.exec(n);
      if (!l) {
        a += n;
        break;
      }
      a += n.substring(0, l.index), n = n.substring(l.index + l[0].length), l[0][0] === "\\" && l[1] ? a += "\\" + (Number(l[1]) + i) : (a += l[0], l[0] === "(" && s++);
    }
    return a;
  }).map((o) => `(${o})`).join(t);
}
const Ce = "(-?)(\\b0[xX][a-fA-F0-9]+|(\\b\\d+(\\.\\d*)?|\\.\\d+)([eE][-+]?\\d+)?)", re = {
  begin: "\\\\[\\s\\S]",
  relevance: 0
}, vt = {
  scope: "string",
  begin: "'",
  end: "'",
  illegal: "\\n",
  contains: [re]
}, bt = {
  scope: "string",
  begin: '"',
  end: '"',
  illegal: "\\n",
  contains: [re]
}, ge = (e, t, s = {}) => {
  const o = U({
    scope: "comment",
    begin: e,
    end: t,
    contains: []
  }, s);
  o.contains.push({
    scope: "doctag",
    begin: "[ ]*(?=(TODO|FIXME|NOTE|BUG|OPTIMIZE|HACK|XXX):)",
    end: /(TODO|FIXME|NOTE|BUG|OPTIMIZE|HACK|XXX):/,
    excludeBegin: !0,
    relevance: 0
  });
  const i = Ae("I", "a", "is", "so", "us", "to", "at", "if", "in", "it", "on", /[A-Za-z]+['](d|ve|re|ll|t|s|n)/, /[A-Za-z]+[-][a-z]+/, /[A-Za-z][a-z]{2,}/);
  return o.contains.push({ begin: Y(/[ ]+/, "(", i, /[.]?[:]?([.][ ]|[ ])/, "){3}") }), o;
}, wt = ge("//", "$"), St = ge("/\\*", "\\*/"), Ot = ge("#", "$");
var ce = Object.freeze({
  __proto__: null,
  MATCH_NOTHING_RE: /\b\B/,
  IDENT_RE: "[a-zA-Z]\\w*",
  UNDERSCORE_IDENT_RE: "[a-zA-Z_]\\w*",
  NUMBER_RE: "\\b\\d+(\\.\\d+)?",
  C_NUMBER_RE: Ce,
  BINARY_NUMBER_RE: "\\b(0b[01]+)",
  RE_STARTERS_RE: "!|!=|!==|%|%=|&|&&|&=|\\*|\\*=|\\+|\\+=|,|-|-=|/=|/|:|;|<<|<<=|<=|<|===|==|=|>>>=|>>=|>=|>>>|>>|>|\\?|\\[|\\{|\\(|\\^|\\^=|\\||\\|=|\\|\\||~",
  SHEBANG: (e = {}) => {
    const t = /^#![ ]*\//;
    return e.binary && (e.begin = Y(t, /.*\b/, e.binary, /\b.*/)), U({
      scope: "meta",
      begin: t,
      end: /$/,
      relevance: 0,
      "on:begin": (s, o) => {
        s.index !== 0 && o.ignoreMatch();
      }
    }, e);
  },
  BACKSLASH_ESCAPE: re,
  APOS_STRING_MODE: vt,
  QUOTE_STRING_MODE: bt,
  PHRASAL_WORDS_MODE: {
    begin: /\b(a|an|the|are|I'm|isn't|don't|doesn't|won't|but|just|should|pretty|simply|enough|gonna|going|wtf|so|such|will|you|your|they|like|more)\b/
  },
  COMMENT: ge,
  C_LINE_COMMENT_MODE: wt,
  C_BLOCK_COMMENT_MODE: St,
  HASH_COMMENT_MODE: Ot,
  NUMBER_MODE: { scope: "number", begin: "\\b\\d+(\\.\\d+)?", relevance: 0 },
  C_NUMBER_MODE: { scope: "number", begin: Ce, relevance: 0 },
  BINARY_NUMBER_MODE: {
    scope: "number",
    begin: "\\b(0b[01]+)",
    relevance: 0
  },
  REGEXP_MODE: {
    begin: /(?=\/[^/\n]*\/)/,
    contains: [{
      scope: "regexp",
      begin: /\//,
      end: /\/[gimuy]*/,
      illegal: /\n/,
      contains: [re, { begin: /\[/, end: /\]/, relevance: 0, contains: [re] }]
    }]
  },
  TITLE_MODE: { scope: "title", begin: "[a-zA-Z]\\w*", relevance: 0 },
  UNDERSCORE_TITLE_MODE: { scope: "title", begin: "[a-zA-Z_]\\w*", relevance: 0 },
  METHOD_GUARD: { begin: "\\.\\s*[a-zA-Z_]\\w*", relevance: 0 },
  END_SAME_AS_BEGIN: (e) => Object.assign(e, { "on:begin": (t, s) => {
    s.data._beginMatch = t[1];
  }, "on:end": (t, s) => {
    s.data._beginMatch !== t[1] && s.ignoreMatch();
  } })
});
function kt(e, t) {
  e.input[e.index - 1] === "." && t.ignoreMatch();
}
function Et(e, t) {
  e.className !== void 0 && (e.scope = e.className, delete e.className);
}
function Ft(e, t) {
  t && e.beginKeywords && (e.begin = "\\b(" + e.beginKeywords.split(" ").join("|") + ")(?!\\.)(?=\\b|\\s)", e.__beforeBegin = kt, e.keywords = e.keywords || e.beginKeywords, delete e.beginKeywords, e.relevance === void 0 && (e.relevance = 0));
}
function _t(e, t) {
  Array.isArray(e.illegal) && (e.illegal = Ae(...e.illegal));
}
function At(e, t) {
  if (e.match) {
    if (e.begin || e.end)
      throw Error("begin & end are not supported with match");
    e.begin = e.match, delete e.match;
  }
}
function It(e, t) {
  e.relevance === void 0 && (e.relevance = 1);
}
const Nt = (e, t) => {
  if (!e.beforeMatch)
    return;
  if (e.starts)
    throw Error("beforeMatch cannot be used with starts");
  const s = Object.assign({}, e);
  Object.keys(e).forEach((o) => {
    delete e[o];
  }), e.keywords = s.keywords, e.begin = Y(s.beforeMatch, De(s.begin)), e.starts = {
    relevance: 0,
    contains: [Object.assign(s, { endsParent: !0 })]
  }, e.relevance = 0, delete s.beforeMatch;
}, xt = ["of", "and", "for", "in", "not", "or", "if", "then", "parent", "list", "value"];
function Ue(e, t, s = "keyword") {
  const o = /* @__PURE__ */ Object.create(null);
  return typeof e == "string" ? i(s, e.split(" ")) : Array.isArray(e) ? i(s, e) : Object.keys(e).forEach((n) => {
    Object.assign(o, Ue(e[n], t, n));
  }), o;
  function i(n, a) {
    t && (a = a.map((l) => l.toLowerCase())), a.forEach((l) => {
      const r = l.split("|");
      o[r[0]] = [n, Tt(r[0], r[1])];
    });
  }
}
function Tt(e, t) {
  return t ? Number(t) : ((s) => xt.includes(s.toLowerCase()))(e) ? 0 : 1;
}
const Le = {}, J = (e) => {
  console.error(e);
}, Re = (e, ...t) => {
  console.log("WARN: " + e, ...t);
}, te = (e, t) => {
  Le[`${e}/${t}`] || (console.log(`Deprecated as of ${e}. ${t}`), Le[`${e}/${t}`] = !0);
}, ue = Error();
function Pe(e, t, { key: s }) {
  let o = 0;
  const i = e[s], n = {}, a = {};
  for (let l = 1; l <= t.length; l++)
    a[l + o] = i[l], n[l + o] = !0, o += Qe(t[l - 1]);
  e[s] = a, e[s]._emit = n, e[s]._multi = !0;
}
function Mt(e) {
  ((t) => {
    t.scope && typeof t.scope == "object" && t.scope !== null && (t.beginScope = t.scope, delete t.scope);
  })(e), typeof e.beginScope == "string" && (e.beginScope = {
    _wrap: e.beginScope
  }), typeof e.endScope == "string" && (e.endScope = {
    _wrap: e.endScope
  }), ((t) => {
    if (Array.isArray(t.begin)) {
      if (t.skip || t.excludeBegin || t.returnBegin)
        throw J("skip, excludeBegin, returnBegin not compatible with beginScope: {}"), ue;
      if (typeof t.beginScope != "object" || t.beginScope === null)
        throw J("beginScope must be object"), ue;
      Pe(t, t.begin, { key: "beginScope" }), t.begin = Ee(t.begin, { joinWith: "" });
    }
  })(e), ((t) => {
    if (Array.isArray(t.end)) {
      if (t.skip || t.excludeEnd || t.returnEnd)
        throw J("skip, excludeEnd, returnEnd not compatible with endScope: {}"), ue;
      if (typeof t.endScope != "object" || t.endScope === null)
        throw J("endScope must be object"), ue;
      Pe(t, t.end, { key: "endScope" }), t.end = Ee(t.end, { joinWith: "" });
    }
  })(e);
}
function Ct(e) {
  function t(i, n) {
    return RegExp(oe(i), "m" + (e.case_insensitive ? "i" : "") + (e.unicodeRegex ? "u" : "") + (n ? "g" : ""));
  }
  class s {
    constructor() {
      this.matchIndexes = {}, this.regexes = [], this.matchAt = 1, this.position = 0;
    }
    addRule(n, a) {
      a.position = this.position++, this.matchIndexes[this.matchAt] = a, this.regexes.push([a, n]), this.matchAt += Qe(n) + 1;
    }
    compile() {
      this.regexes.length === 0 && (this.exec = () => null);
      const n = this.regexes.map((a) => a[1]);
      this.matcherRe = t(Ee(n, {
        joinWith: "|"
      }), !0), this.lastIndex = 0;
    }
    exec(n) {
      this.matcherRe.lastIndex = this.lastIndex;
      const a = this.matcherRe.exec(n);
      if (!a)
        return null;
      const l = a.findIndex((v, m) => m > 0 && v !== void 0), r = this.matchIndexes[l];
      return a.splice(0, l), Object.assign(a, r);
    }
  }
  class o {
    constructor() {
      this.rules = [], this.multiRegexes = [], this.count = 0, this.lastIndex = 0, this.regexIndex = 0;
    }
    getMatcher(n) {
      if (this.multiRegexes[n])
        return this.multiRegexes[n];
      const a = new s();
      return this.rules.slice(n).forEach(([l, r]) => a.addRule(l, r)), a.compile(), this.multiRegexes[n] = a, a;
    }
    resumingScanAtSamePosition() {
      return this.regexIndex !== 0;
    }
    considerAll() {
      this.regexIndex = 0;
    }
    addRule(n, a) {
      this.rules.push([n, a]), a.type === "begin" && this.count++;
    }
    exec(n) {
      const a = this.getMatcher(this.regexIndex);
      a.lastIndex = this.lastIndex;
      let l = a.exec(n);
      if (this.resumingScanAtSamePosition() && !(l && l.index === this.lastIndex)) {
        const r = this.getMatcher(0);
        r.lastIndex = this.lastIndex + 1, l = r.exec(n);
      }
      return l && (this.regexIndex += l.position + 1, this.regexIndex === this.count && this.considerAll()), l;
    }
  }
  if (e.compilerExtensions || (e.compilerExtensions = []), e.contains && e.contains.includes("self"))
    throw Error("ERR: contains `self` is not supported at the top-level of a language.  See documentation.");
  return e.classNameAliases = U(e.classNameAliases || {}), function i(n, a) {
    const l = n;
    if (n.isCompiled)
      return l;
    [Et, At, Mt, Nt].forEach((v) => v(n, a)), e.compilerExtensions.forEach((v) => v(n, a)), n.__beforeBegin = null, [Ft, _t, It].forEach((v) => v(n, a)), n.isCompiled = !0;
    let r = null;
    return typeof n.keywords == "object" && n.keywords.$pattern && (n.keywords = Object.assign({}, n.keywords), r = n.keywords.$pattern, delete n.keywords.$pattern), r = r || /\w+/, n.keywords && (n.keywords = Ue(n.keywords, e.case_insensitive)), l.keywordPatternRe = t(r, !0), a && (n.begin || (n.begin = /\B|\b/), l.beginRe = t(l.begin), n.end || n.endsWithParent || (n.end = /\B|\b/), n.end && (l.endRe = t(l.end)), l.terminatorEnd = oe(l.end) || "", n.endsWithParent && a.terminatorEnd && (l.terminatorEnd += (n.end ? "|" : "") + a.terminatorEnd)), n.illegal && (l.illegalRe = t(n.illegal)), n.contains || (n.contains = []), n.contains = [].concat(...n.contains.map((v) => ((m) => (m.variants && !m.cachedVariants && (m.cachedVariants = m.variants.map((C) => U(m, {
      variants: null
    }, C))), m.cachedVariants ? m.cachedVariants : Ze(m) ? U(m, {
      starts: m.starts ? U(m.starts) : null
    }) : Object.isFrozen(m) ? U(m) : m))(v === "self" ? n : v))), n.contains.forEach((v) => {
      i(v, l);
    }), n.starts && i(n.starts, a), l.matcher = ((v) => {
      const m = new o();
      return v.contains.forEach((C) => m.addRule(C.begin, {
        rule: C,
        type: "begin"
      })), v.terminatorEnd && m.addRule(v.terminatorEnd, {
        type: "end"
      }), v.illegal && m.addRule(v.illegal, { type: "illegal" }), m;
    })(l), l;
  }(e);
}
function Ze(e) {
  return !!e && (e.endsWithParent || Ze(e.starts));
}
class Lt extends Error {
  constructor(t, s) {
    super(t), this.name = "HTMLInjectionError", this.html = s;
  }
}
const be = He, je = U, Be = Symbol("nomatch");
var Fe = ((e) => {
  const t = /* @__PURE__ */ Object.create(null), s = /* @__PURE__ */ Object.create(null), o = [];
  let i = !0;
  const n = "Could not find the language '{}', did you forget to load/include a language module?", a = {
    disableAutodetect: !0,
    name: "Plain text",
    contains: []
  };
  let l = {
    ignoreUnescapedHTML: !1,
    throwUnescapedHTML: !1,
    noHighlightRe: /^(no-?highlight)$/i,
    languageDetectRe: /\blang(?:uage)?-([\w-]+)\b/i,
    classPrefix: "hljs-",
    cssSelector: "pre code",
    languages: null,
    __emitter: gt
  };
  function r(c) {
    return l.noHighlightRe.test(c);
  }
  function v(c, f, y) {
    let I = "", F = "";
    typeof f == "object" ? (I = c, y = f.ignoreIllegals, F = f.language) : (te("10.7.0", "highlight(lang, code, ...args) has been deprecated."), te("10.7.0", `Please use highlight(code, options) instead.
https://github.com/highlightjs/highlight.js/issues/2277`), F = c, I = f), y === void 0 && (y = !0);
    const k = { code: I, language: F };
    K("before:highlight", k);
    const N = k.result ? k.result : m(k.language, k.code, y);
    return N.code = k.code, K("after:highlight", N), N;
  }
  function m(c, f, y, I) {
    const F = /* @__PURE__ */ Object.create(null);
    function k() {
      if (!p.keywords)
        return void A.addText(w);
      let u = 0;
      p.keywordPatternRe.lastIndex = 0;
      let g = p.keywordPatternRe.exec(w), O = "";
      for (; g; ) {
        O += w.substring(u, g.index);
        const E = z.case_insensitive ? g[0].toLowerCase() : g[0], T = (S = E, p.keywords[S]);
        if (T) {
          const [D, ye] = T;
          if (A.addText(O), O = "", F[E] = (F[E] || 0) + 1, F[E] <= 7 && (q += ye), D.startsWith("_"))
            O += g[0];
          else {
            const le = z.classNameAliases[D] || D;
            A.addKeyword(g[0], le);
          }
        } else
          O += g[0];
        u = p.keywordPatternRe.lastIndex, g = p.keywordPatternRe.exec(w);
      }
      var S;
      O += w.substring(u), A.addText(O);
    }
    function N() {
      p.subLanguage != null ? (() => {
        if (w === "")
          return;
        let u = null;
        if (typeof p.subLanguage == "string") {
          if (!t[p.subLanguage])
            return void A.addText(w);
          u = m(p.subLanguage, w, !0, ee[p.subLanguage]), ee[p.subLanguage] = u._top;
        } else
          u = C(w, p.subLanguage.length ? p.subLanguage : null);
        p.relevance > 0 && (q += u.relevance), A.addSublanguage(u._emitter, u.language);
      })() : k(), w = "";
    }
    function M(u, g) {
      let O = 1;
      const S = g.length - 1;
      for (; O <= S; ) {
        if (!u._emit[O]) {
          O++;
          continue;
        }
        const E = z.classNameAliases[u[O]] || u[O], T = g[O];
        E ? A.addKeyword(T, E) : (w = T, k(), w = ""), O++;
      }
    }
    function _(u, g) {
      return u.scope && typeof u.scope == "string" && A.openNode(z.classNameAliases[u.scope] || u.scope), u.beginScope && (u.beginScope._wrap ? (A.addKeyword(w, z.classNameAliases[u.beginScope._wrap] || u.beginScope._wrap), w = "") : u.beginScope._multi && (M(u.beginScope, g), w = "")), p = Object.create(u, { parent: {
        value: p
      } }), p;
    }
    function R(u, g, O) {
      let S = ((E, T) => {
        const D = E && E.exec(T);
        return D && D.index === 0;
      })(u.endRe, O);
      if (S) {
        if (u["on:end"]) {
          const E = new xe(u);
          u["on:end"](g, E), E.isMatchIgnored && (S = !1);
        }
        if (S) {
          for (; u.endsParent && u.parent; )
            u = u.parent;
          return u;
        }
      }
      if (u.endsWithParent)
        return R(u.parent, g, O);
    }
    function ae(u) {
      return p.matcher.regexIndex === 0 ? (w += u[0], 1) : (me = !0, 0);
    }
    function fe(u) {
      const g = u[0], O = f.substring(u.index), S = R(p, u, O);
      if (!S)
        return Be;
      const E = p;
      p.endScope && p.endScope._wrap ? (N(), A.addKeyword(g, p.endScope._wrap)) : p.endScope && p.endScope._multi ? (N(), M(p.endScope, u)) : E.skip ? w += g : (E.returnEnd || E.excludeEnd || (w += g), N(), E.excludeEnd && (w = g));
      do
        p.scope && A.closeNode(), p.skip || p.subLanguage || (q += p.relevance), p = p.parent;
      while (p !== S.parent);
      return S.starts && _(S.starts, u), E.returnEnd ? 0 : g.length;
    }
    let $ = {};
    function se(u, g) {
      const O = g && g[0];
      if (w += u, O == null)
        return N(), 0;
      if ($.type === "begin" && g.type === "end" && $.index === g.index && O === "") {
        if (w += f.slice(g.index, g.index + 1), !i) {
          const S = Error(`0 width match regex (${c})`);
          throw S.languageName = c, S.badRule = $.rule, S;
        }
        return 1;
      }
      if ($ = g, g.type === "begin")
        return ((S) => {
          const E = S[0], T = S.rule, D = new xe(T), ye = [T.__beforeBegin, T["on:begin"]];
          for (const le of ye)
            if (le && (le(S, D), D.isMatchIgnored))
              return ae(E);
          return T.skip ? w += E : (T.excludeBegin && (w += E), N(), T.returnBegin || T.excludeBegin || (w = E)), _(T, S), T.returnBegin ? 0 : E.length;
        })(g);
      if (g.type === "illegal" && !y) {
        const S = Error('Illegal lexeme "' + O + '" for mode "' + (p.scope || "<unnamed>") + '"');
        throw S.mode = p, S;
      }
      if (g.type === "end") {
        const S = fe(g);
        if (S !== Be)
          return S;
      }
      if (g.type === "illegal" && O === "")
        return 1;
      if (ie > 1e5 && ie > 3 * g.index)
        throw Error("potential infinite loop, way more iterations than matches");
      return w += O, O.length;
    }
    const z = B(c);
    if (!z)
      throw J(n.replace("{}", c)), Error('Unknown language: "' + c + '"');
    const G = Ct(z);
    let X = "", p = I || G;
    const ee = {}, A = new l.__emitter(l);
    (() => {
      const u = [];
      for (let g = p; g !== z; g = g.parent)
        g.scope && u.unshift(g.scope);
      u.forEach((g) => A.openNode(g));
    })();
    let w = "", q = 0, H = 0, ie = 0, me = !1;
    try {
      for (p.matcher.considerAll(); ; ) {
        ie++, me ? me = !1 : p.matcher.considerAll(), p.matcher.lastIndex = H;
        const u = p.matcher.exec(f);
        if (!u)
          break;
        const g = se(f.substring(H, u.index), u);
        H = u.index + g;
      }
      return se(f.substring(H)), A.closeAllNodes(), A.finalize(), X = A.toHTML(), {
        language: c,
        value: X,
        relevance: q,
        illegal: !1,
        _emitter: A,
        _top: p
      };
    } catch (u) {
      if (u.message && u.message.includes("Illegal"))
        return {
          language: c,
          value: be(f),
          illegal: !0,
          relevance: 0,
          _illegalBy: {
            message: u.message,
            index: H,
            context: f.slice(H - 100, H + 100),
            mode: u.mode,
            resultSoFar: X
          },
          _emitter: A
        };
      if (i)
        return {
          language: c,
          value: be(f),
          illegal: !1,
          relevance: 0,
          errorRaised: u,
          _emitter: A,
          _top: p
        };
      throw u;
    }
  }
  function C(c, f) {
    f = f || l.languages || Object.keys(t);
    const y = ((_) => {
      const R = { value: be(_), illegal: !1, relevance: 0, _top: a, _emitter: new l.__emitter(l) };
      return R._emitter.addText(_), R;
    })(c), I = f.filter(B).filter(ne).map((_) => m(_, c, !1));
    I.unshift(y);
    const F = I.sort((_, R) => {
      if (_.relevance !== R.relevance)
        return R.relevance - _.relevance;
      if (_.language && R.language) {
        if (B(_.language).supersetOf === R.language)
          return 1;
        if (B(R.language).supersetOf === _.language)
          return -1;
      }
      return 0;
    }), [k, N] = F, M = k;
    return M.secondBest = N, M;
  }
  function V(c) {
    let f = null;
    const y = ((k) => {
      let N = k.className + " ";
      N += k.parentNode ? k.parentNode.className : "";
      const M = l.languageDetectRe.exec(N);
      if (M) {
        const _ = B(M[1]);
        return _ || (Re(n.replace("{}", M[1])), Re("Falling back to no-highlight mode for this block.", k)), _ ? M[1] : "no-highlight";
      }
      return N.split(/\s+/).find((_) => r(_) || B(_));
    })(c);
    if (r(y))
      return;
    if (K("before:highlightElement", {
      el: c,
      language: y
    }), c.children.length > 0 && (l.ignoreUnescapedHTML || (console.warn("One of your code blocks includes unescaped HTML. This is a potentially serious security risk."), console.warn("https://github.com/highlightjs/highlight.js/wiki/security"), console.warn("The element with unescaped HTML:"), console.warn(c)), l.throwUnescapedHTML))
      throw new Lt("One of your code blocks includes unescaped HTML.", c.innerHTML);
    f = c;
    const I = f.textContent, F = y ? v(I, { language: y, ignoreIllegals: !0 }) : C(I);
    c.innerHTML = F.value, ((k, N, M) => {
      const _ = N && s[N] || M;
      k.classList.add("hljs"), k.classList.add("language-" + _);
    })(c, y, F.language), c.result = {
      language: F.language,
      re: F.relevance,
      relevance: F.relevance
    }, F.secondBest && (c.secondBest = {
      language: F.secondBest.language,
      relevance: F.secondBest.relevance
    }), K("after:highlightElement", { el: c, result: F, text: I });
  }
  let Z = !1;
  function W() {
    document.readyState !== "loading" ? document.querySelectorAll(l.cssSelector).forEach(V) : Z = !0;
  }
  function B(c) {
    return c = (c || "").toLowerCase(), t[c] || t[s[c]];
  }
  function Q(c, { languageName: f }) {
    typeof c == "string" && (c = [c]), c.forEach((y) => {
      s[y.toLowerCase()] = f;
    });
  }
  function ne(c) {
    const f = B(c);
    return f && !f.disableAutodetect;
  }
  function K(c, f) {
    const y = c;
    o.forEach((I) => {
      I[y] && I[y](f);
    });
  }
  typeof window < "u" && window.addEventListener && window.addEventListener("DOMContentLoaded", () => {
    Z && W();
  }, !1), Object.assign(e, {
    highlight: v,
    highlightAuto: C,
    highlightAll: W,
    highlightElement: V,
    highlightBlock: (c) => (te("10.7.0", "highlightBlock will be removed entirely in v12.0"), te("10.7.0", "Please use highlightElement now."), V(c)),
    configure: (c) => {
      l = je(l, c);
    },
    initHighlighting: () => {
      W(), te("10.6.0", "initHighlighting() deprecated.  Use highlightAll() now.");
    },
    initHighlightingOnLoad: () => {
      W(), te("10.6.0", "initHighlightingOnLoad() deprecated.  Use highlightAll() now.");
    },
    registerLanguage: (c, f) => {
      let y = null;
      try {
        y = f(e);
      } catch (I) {
        if (J("Language definition for '{}' could not be registered.".replace("{}", c)), !i)
          throw I;
        J(I), y = a;
      }
      y.name || (y.name = c), t[c] = y, y.rawDefinition = f.bind(null, e), y.aliases && Q(y.aliases, {
        languageName: c
      });
    },
    unregisterLanguage: (c) => {
      delete t[c];
      for (const f of Object.keys(s))
        s[f] === c && delete s[f];
    },
    listLanguages: () => Object.keys(t),
    getLanguage: B,
    registerAliases: Q,
    autoDetection: ne,
    inherit: je,
    addPlugin: (c) => {
      ((f) => {
        f["before:highlightBlock"] && !f["before:highlightElement"] && (f["before:highlightElement"] = (y) => {
          f["before:highlightBlock"](Object.assign({ block: y.el }, y));
        }), f["after:highlightBlock"] && !f["after:highlightElement"] && (f["after:highlightElement"] = (y) => {
          f["after:highlightBlock"](Object.assign({ block: y.el }, y));
        });
      })(c), o.push(c);
    }
  }), e.debugMode = () => {
    i = !1;
  }, e.safeMode = () => {
    i = !0;
  }, e.versionString = "11.7.0", e.regex = {
    concat: Y,
    lookahead: De,
    either: Ae,
    optional: mt,
    anyNumberOfTimes: ft
  };
  for (const c in ce)
    typeof ce[c] == "object" && Oe.exports(ce[c]);
  return Object.assign(e, ce), e;
})({});
/*! `javascript` grammar compiled for Highlight.js 11.7.0 */
var Rt = (() => {
  const e = "[A-Za-z$_][0-9A-Za-z$_]*", t = ["as", "in", "of", "if", "for", "while", "finally", "var", "new", "function", "do", "return", "void", "else", "break", "catch", "instanceof", "with", "throw", "case", "default", "try", "switch", "continue", "typeof", "delete", "let", "yield", "const", "class", "debugger", "async", "await", "static", "import", "from", "export", "extends"], s = ["true", "false", "null", "undefined", "NaN", "Infinity"], o = ["Object", "Function", "Boolean", "Symbol", "Math", "Date", "Number", "BigInt", "String", "RegExp", "Array", "Float32Array", "Float64Array", "Int8Array", "Uint8Array", "Uint8ClampedArray", "Int16Array", "Int32Array", "Uint16Array", "Uint32Array", "BigInt64Array", "BigUint64Array", "Set", "Map", "WeakSet", "WeakMap", "ArrayBuffer", "SharedArrayBuffer", "Atomics", "DataView", "JSON", "Promise", "Generator", "GeneratorFunction", "AsyncFunction", "Reflect", "Proxy", "Intl", "WebAssembly"], i = ["Error", "EvalError", "InternalError", "RangeError", "ReferenceError", "SyntaxError", "TypeError", "URIError"], n = ["setInterval", "setTimeout", "clearInterval", "clearTimeout", "require", "exports", "eval", "isFinite", "isNaN", "parseFloat", "parseInt", "decodeURI", "decodeURIComponent", "encodeURI", "encodeURIComponent", "escape", "unescape"], a = ["arguments", "this", "super", "console", "window", "document", "localStorage", "module", "global"], l = [].concat(n, o, i);
  return (r) => {
    const v = r.regex, m = e, C = {
      begin: /<[A-Za-z0-9\\._:-]+/,
      end: /\/[A-Za-z0-9\\._:-]+>|\/>/,
      isTrulyOpeningTag: (G, X) => {
        const p = G[0].length + G.index, ee = G.input[p];
        if (ee === "<" || ee === ",")
          return void X.ignoreMatch();
        let A;
        ee === ">" && (((q, { after: H }) => {
          const ie = "</" + q[0].slice(1);
          return q.input.indexOf(ie, H) !== -1;
        })(G, { after: p }) || X.ignoreMatch());
        const w = G.input.substring(p);
        ((A = w.match(/^\s*=/)) || (A = w.match(/^\s+extends\s+/)) && A.index === 0) && X.ignoreMatch();
      }
    }, V = {
      $pattern: e,
      keyword: t,
      literal: s,
      built_in: l,
      "variable.language": a
    }, Z = "\\.([0-9](_?[0-9])*)", W = "0|[1-9](_?[0-9])*|0[0-7]*[89][0-9]*", B = {
      className: "number",
      variants: [{
        begin: `(\\b(${W})((${Z})|\\.)?|(${Z}))[eE][+-]?([0-9](_?[0-9])*)\\b`
      }, {
        begin: `\\b(${W})\\b((${Z})\\b|\\.)?|(${Z})\\b`
      }, {
        begin: "\\b(0|[1-9](_?[0-9])*)n\\b"
      }, {
        begin: "\\b0[xX][0-9a-fA-F](_?[0-9a-fA-F])*n?\\b"
      }, {
        begin: "\\b0[bB][0-1](_?[0-1])*n?\\b"
      }, { begin: "\\b0[oO][0-7](_?[0-7])*n?\\b" }, {
        begin: "\\b0[0-7]+n?\\b"
      }],
      relevance: 0
    }, Q = {
      className: "subst",
      begin: "\\$\\{",
      end: "\\}",
      keywords: V,
      contains: []
    }, ne = { begin: "html`", end: "", starts: {
      end: "`",
      returnEnd: !1,
      contains: [r.BACKSLASH_ESCAPE, Q],
      subLanguage: "xml"
    } }, K = {
      begin: "css`",
      end: "",
      starts: {
        end: "`",
        returnEnd: !1,
        contains: [r.BACKSLASH_ESCAPE, Q],
        subLanguage: "css"
      }
    }, c = {
      className: "string",
      begin: "`",
      end: "`",
      contains: [r.BACKSLASH_ESCAPE, Q]
    }, f = {
      className: "comment",
      variants: [r.COMMENT(/\/\*\*(?!\/)/, "\\*/", {
        relevance: 0,
        contains: [{
          begin: "(?=@[A-Za-z]+)",
          relevance: 0,
          contains: [{
            className: "doctag",
            begin: "@[A-Za-z]+"
          }, {
            className: "type",
            begin: "\\{",
            end: "\\}",
            excludeEnd: !0,
            excludeBegin: !0,
            relevance: 0
          }, {
            className: "variable",
            begin: m + "(?=\\s*(-)|$)",
            endsParent: !0,
            relevance: 0
          }, { begin: /(?=[^\n])\s/, relevance: 0 }]
        }]
      }), r.C_BLOCK_COMMENT_MODE, r.C_LINE_COMMENT_MODE]
    }, y = [r.APOS_STRING_MODE, r.QUOTE_STRING_MODE, ne, K, c, { match: /\$\d+/ }, B];
    Q.contains = y.concat({
      begin: /\{/,
      end: /\}/,
      keywords: V,
      contains: ["self"].concat(y)
    });
    const I = [].concat(f, Q.contains), F = I.concat([{
      begin: /\(/,
      end: /\)/,
      keywords: V,
      contains: ["self"].concat(I)
    }]), k = {
      className: "params",
      begin: /\(/,
      end: /\)/,
      excludeBegin: !0,
      excludeEnd: !0,
      keywords: V,
      contains: F
    }, N = { variants: [{
      match: [/class/, /\s+/, m, /\s+/, /extends/, /\s+/, v.concat(m, "(", v.concat(/\./, m), ")*")],
      scope: { 1: "keyword", 3: "title.class", 5: "keyword", 7: "title.class.inherited" }
    }, {
      match: [/class/, /\s+/, m],
      scope: { 1: "keyword", 3: "title.class" }
    }] }, M = {
      relevance: 0,
      match: v.either(/\bJSON/, /\b[A-Z][a-z]+([A-Z][a-z]*|\d)*/, /\b[A-Z]{2,}([A-Z][a-z]+|\d)+([A-Z][a-z]*)*/, /\b[A-Z]{2,}[a-z]+([A-Z][a-z]+|\d)*([A-Z][a-z]*)*/),
      className: "title.class",
      keywords: { _: [...o, ...i] }
    }, _ = {
      variants: [{
        match: [/function/, /\s+/, m, /(?=\s*\()/]
      }, { match: [/function/, /\s*(?=\()/] }],
      className: { 1: "keyword", 3: "title.function" },
      label: "func.def",
      contains: [k],
      illegal: /%/
    }, R = {
      match: v.concat(/\b/, (ae = [...n, "super", "import"], v.concat("(?!", ae.join("|"), ")")), m, v.lookahead(/\(/)),
      className: "title.function",
      relevance: 0
    };
    var ae;
    const fe = {
      begin: v.concat(/\./, v.lookahead(v.concat(m, /(?![0-9A-Za-z$_(])/))),
      end: m,
      excludeBegin: !0,
      keywords: "prototype",
      className: "property",
      relevance: 0
    }, $ = {
      match: [/get|set/, /\s+/, m, /(?=\()/],
      className: { 1: "keyword", 3: "title.function" },
      contains: [{ begin: /\(\)/ }, k]
    }, se = "(\\([^()]*(\\([^()]*(\\([^()]*\\)[^()]*)*\\)[^()]*)*\\)|" + r.UNDERSCORE_IDENT_RE + ")\\s*=>", z = {
      match: [/const|var|let/, /\s+/, m, /\s*/, /=\s*/, /(async\s*)?/, v.lookahead(se)],
      keywords: "async",
      className: { 1: "keyword", 3: "title.function" },
      contains: [k]
    };
    return {
      name: "Javascript",
      aliases: ["js", "jsx", "mjs", "cjs"],
      keywords: V,
      exports: {
        PARAMS_CONTAINS: F,
        CLASS_REFERENCE: M
      },
      illegal: /#(?![$_A-z])/,
      contains: [r.SHEBANG({ label: "shebang", binary: "node", relevance: 5 }), {
        label: "use_strict",
        className: "meta",
        relevance: 10,
        begin: /^\s*['"]use (strict|asm)['"]/
      }, r.APOS_STRING_MODE, r.QUOTE_STRING_MODE, ne, K, c, f, { match: /\$\d+/ }, B, M, {
        className: "attr",
        begin: m + v.lookahead(":"),
        relevance: 0
      }, z, {
        begin: "(" + r.RE_STARTERS_RE + "|\\b(case|return|throw)\\b)\\s*",
        keywords: "return throw case",
        relevance: 0,
        contains: [f, r.REGEXP_MODE, {
          className: "function",
          begin: se,
          returnBegin: !0,
          end: "\\s*=>",
          contains: [{
            className: "params",
            variants: [{ begin: r.UNDERSCORE_IDENT_RE, relevance: 0 }, {
              className: null,
              begin: /\(\s*\)/,
              skip: !0
            }, {
              begin: /\(/,
              end: /\)/,
              excludeBegin: !0,
              excludeEnd: !0,
              keywords: V,
              contains: F
            }]
          }]
        }, { begin: /,/, relevance: 0 }, {
          match: /\s+/,
          relevance: 0
        }, { variants: [{ begin: "<>", end: "</>" }, {
          match: /<[A-Za-z0-9\\._:-]+\s*\/>/
        }, {
          begin: C.begin,
          "on:begin": C.isTrulyOpeningTag,
          end: C.end
        }], subLanguage: "xml", contains: [{
          begin: C.begin,
          end: C.end,
          skip: !0,
          contains: ["self"]
        }] }]
      }, _, {
        beginKeywords: "while if switch catch for"
      }, {
        begin: "\\b(?!function)" + r.UNDERSCORE_IDENT_RE + "\\([^()]*(\\([^()]*(\\([^()]*\\)[^()]*)*\\)[^()]*)*\\)\\s*\\{",
        returnBegin: !0,
        label: "func.def",
        contains: [k, r.inherit(r.TITLE_MODE, {
          begin: m,
          className: "title.function"
        })]
      }, { match: /\.\.\./, relevance: 0 }, fe, {
        match: "\\$" + m,
        relevance: 0
      }, {
        match: [/\bconstructor(?=\s*\()/],
        className: { 1: "title.function" },
        contains: [k]
      }, R, {
        relevance: 0,
        match: /\b[A-Z][A-Z_0-9]+\b/,
        className: "variable.constant"
      }, N, $, { match: /\$[(.]/ }]
    };
  };
})();
Fe.registerLanguage("javascript", Rt);
let we = {};
const Pt = {
  name: "NodeComplex",
  inheritAttrs: !1,
  emits: ["show", "open", "toggle", "focus", "openParent", "forget"],
  props: {
    // ref
    root: void 0,
    rootId: [String, Number],
    // options
    modelValue: void 0,
    name: [String, Number],
    getAllProperties: Boolean,
    openLevel: [Number, Array],
    openSpecific: Array,
    startClosed: Boolean,
    longText: Number,
    escapeQuotes: Boolean,
    deep: Boolean,
    watch: Boolean,
    preview: [Boolean, Number],
    previewInitial: Boolean,
    focus: [String, Number],
    arrow: Boolean,
    arrowOpen: String,
    arrowClosed: String,
    delimiter: String,
    more: String,
    save: Boolean,
    saveFocus: Boolean,
    // helpers
    shared: Object,
    type: String,
    parentType: String,
    parentOpen: Boolean,
    pointer: { type: [String, Number], default: "" },
    level: { type: Number, default: 0 },
    size: Number,
    position: Number,
    // functions
    escapeQuotesFn: Function,
    isPrimitiveFn: Function,
    getTypeFn: Function,
    unwrapSpecificFn: Function,
    emitFn: Function
  },
  data() {
    return {
      id: this.getId(),
      hideTimes: 0,
      isOpen: !1,
      expanded: !1,
      openSublevel: !1,
      items: [],
      getMapSet: {},
      getSize: 0,
      useOpenLevel: this.openLevel,
      useOpenSpecific: this.openSpecific,
      originalOpenLevel: this.openLevel,
      askForget: !1,
      cleared: !1,
      hover: !1,
      unwatch: () => {
      },
      initializedClosed: !1
    };
  },
  mounted() {
    this.showEmit();
  },
  created() {
    this.expanded = this.allowPreview, this.items = this.makeItems(), this.watch && (this.unwatch = this.watchModelValue(this.deep)), this.useOpenSpecific = this.openSpecific;
  },
  methods: {
    showEmit() {
      return this.emit("show", {
        pointer: this.pointer,
        focusElement: this.$refs.focusElement,
        type: "complex"
      }), !0;
    },
    getAllPointer(e) {
      let t = "*";
      if (e = String(e), e in we)
        t = we[e];
      else {
        const s = e.split(this.delimiter);
        s.pop(), s.length && (t = s.join(this.delimiter) + this.delimiter + "*"), we[e] = t;
      }
      return t;
    },
    forget() {
      this.emitFn(this, "forget", { askForget: this.askForget }), this.askForget = !1, this.cleared = !0, setTimeout(() => this.cleared = !1, 1e3);
    },
    openParent() {
      this.isOpen || this.toggleOpen(null, !0);
    },
    getId() {
      return this.level === 0 ? `_${this.rootId}` : `_${this.rootId}${this.delimiter}${this.pointer}`;
    },
    watchModelValue(e) {
      return this.$watch(
        "modelValue",
        () => {
          this.items = this.makeItems();
        },
        { deep: e }
      );
    },
    getPointer(e) {
      return this.pointer ? this.pointer + this.delimiter + e : String(e);
    },
    getSpecialType(e) {
      return this.isMapSet ? this.getTypeFn(this.getMapSet[e]) : this.getTypeFn(this.modelValue[e]);
    },
    getModelValue(e) {
      return this.isMapSet ? this.getMapSet[e] : this.modelValue[e];
    },
    // prevent select on double click
    preventSelect(e) {
      e.detail > 1 && e.preventDefault();
    },
    /**
     * Get the name of key of an object or array
     * If it is an array, those keys are not named
     * @param key
     * @returns {string|*}
     */
    getName(e) {
      return this.isArray ? "" : e;
    },
    expand() {
      this.isOpen || this.toggleOpen(null, !0), this.expanded = !0, this.openSublevel = !0;
    },
    toggleOpen(e, t) {
      const s = t === void 0 ? !this.isOpen : t;
      this.setOpen(s, { user: !0 }), this.emit("toggle", {
        event: e,
        isOpen: this.isOpen,
        level: this.level,
        pointer: this.pointer
      });
    },
    emit(e, ...t) {
      this.emitFn(this, e, ...t);
    },
    makeClassItems(e) {
      let t = Object.getPrototypeOf(e), s = [];
      for (; t && t.constructor.name !== "Object"; )
        s.push.apply(s, Object.getOwnPropertyNames(t)), t = Object.getPrototypeOf(t.constructor.prototype);
      let o = Array.from(
        new Set(
          Object.getOwnPropertyNames(e).concat(s)
        )
      ), i = o.length;
      if (!this.isOpen) {
        const n = parseInt(this.preview);
        let a = 0;
        for (; a < i && a !== n; )
          o[a] = o[a], a++;
      }
      return { keys: o, keysLength: i };
    },
    makeItems() {
      let e = [], t = 0;
      switch (!0) {
        case this.isObject:
          switch (!0) {
            case this.isSet:
              this.getMapSet = Array.from(this.modelValue), e = [...Array(this.getMapSet.length).keys()], this.getSize = this.getMapSet.length;
              break;
            case this.isMap:
              this.modelValue.forEach((o, i) => {
                this.getMapSet[i] = o, e[t] = i, t++;
              }), this.getSize = t;
              break;
            default:
              if (this.getAllProperties) {
                const o = this.makeClassItems(this.modelValue);
                e = o.keys, this.getSize = o.keysLength;
              } else {
                if (this.isOpen)
                  for (let o in this.modelValue)
                    e[t] = o, t++;
                else {
                  const o = parseInt(this.preview);
                  for (let i in this.modelValue) {
                    if (t === o)
                      break;
                    e[t] = i, t++;
                  }
                }
                this.getSize = t;
              }
          }
          return e;
        case this.isArray:
          return this.getSize = this.modelValue.length, [...Array(this.modelValue.length).keys()];
        case this.isClass:
          const s = this.makeClassItems(this.modelValue);
          return e = s.keys, this.getSize = s.keysLength, e;
        default:
          return this.modelValue;
      }
    },
    parentIsOpen() {
      return this.$parent.$options.name === "NodeComplex" && this.$parent.isOpen || this.$parent.$options.name === "VueDd";
    },
    focusEmit() {
      this.emit("focus", {
        pointer: this.pointer,
        focusElement: this.$refs.focusElement
      });
    },
    setOpen(e, { user: t }) {
      this.isOpen = e, this.emit("open", {
        isOpen: this.isOpen,
        level: this.level,
        pointer: this.pointer,
        user: t
      }), this.expanded = this.allowPreview, this.isOpen && this.$emit("openParent");
    },
    openPointer(e) {
      e ? (Ne(() => this.setOpen(!0, { user: !1 })), this.openSublevel = !1) : this.closePointer();
    },
    closePointer() {
      const e = this.parentIsOpen() || this.openLevel === 0;
      this.setOpen(this.openSublevel && e, { user: !1 }), this.openSublevel = !1;
    },
    open() {
      this.toggleOpen(null, !0);
    },
    close() {
      this.toggleOpen(null, !1);
    },
    toggle() {
      this.toggleOpen(null, !this.isOpen);
    }
  },
  computed: {
    parentIsArray() {
      return this.parentType === "array";
    },
    unwrapSpecific() {
      return this.unwrapSpecificFn(this.openSpecific);
    },
    allowPreview() {
      return !this.previewInitial && this.level === 0 ? !1 : this.preview;
    },
    isMap() {
      return this.isObject && this.modelValue instanceof Map;
    },
    isSet() {
      return this.isObject && this.modelValue instanceof Set;
    },
    isMapSet() {
      return this.isMap || this.isSet;
    },
    instanceOf() {
      const e = this.isObject && "constructor" in this.modelValue && "name" in this.modelValue.constructor ? this.modelValue.constructor.name : "";
      return e === "Object" ? "" : e;
    },
    nextLevel() {
      return this.level + 1;
    },
    charClass() {
      return this.isObject ? "vue-dd-obj-char" : "vue-dd-arr-char";
    },
    charOpen() {
      return this.isArray ? "[" : "{";
    },
    charClose() {
      return this.isArray ? "]" : "}";
    },
    functionInlinePreview() {
      const e = this.items.toString(), t = 100;
      return e.length > t ? e.substring(0, t) + "...}" : e;
    },
    functionInline() {
      let e = this.modelValue.toString();
      switch (!0) {
        case e.startsWith("function "):
          e = e.substring(9).trim(), e.startsWith(this.name) && (e = e.substring(this.name.length));
          break;
        case e.startsWith("()"):
          e = "(){...}";
          break;
        case e.startsWith(this.name):
          e = e.substring(this.name.length);
          break;
      }
      const t = 25;
      return e.length > t && (e = e.substring(0, t) + "..."), e;
    },
    functionName() {
      let e = String(this.items);
      const t = e.indexOf(`
`);
      return t >= 0 && (e = e.substring(0, t)), Fe.highlight(e, { language: "javascript" }).value;
    },
    functionContent() {
      let e = String(this.items).trim().split(`
`);
      if (e.length) {
        const t = e.length - 1, s = e[t].indexOf("}");
        e = e.map((n) => n.substring(s)), e.shift();
        const o = e.join(`
`);
        return Fe.highlight(o, { language: "javascript" }).value;
      }
      return "";
    },
    shouldComma() {
      return this.size && this.position && this.position !== this.size;
    },
    longTextInline() {
      let e = this.modelValue.toString().substring(0, this.longText);
      return e = this.escapeQuotesFn(e), e = `"${e}..."`, e;
    },
    longTextContent() {
      let e = this.modelValue;
      return e = this.escapeQuotesFn(e), e = `"${e}"`, e;
    },
    isLongText() {
      return this.type === "longtext";
    },
    isRefReactive() {
      return this.isRef || this.isReactive;
    },
    isIterable() {
      return this.isArray || this.isObject || this.isClass;
    },
    isArray() {
      return this.type === "array";
    },
    isObject() {
      return this.type === "object";
    },
    isFunction() {
      return this.type === "function";
    },
    isClass() {
      return this.type === "class";
    },
    isPromise() {
      return ut(this.modelValue);
    },
    isReactive() {
      return We(this.modelValue);
    },
    isRef() {
      return Ve(this.modelValue);
    },
    isFocused() {
      return String(this.pointer) === String(this.focus);
    },
    showName() {
      return !this.parentIsArray && this.nameString || this.parentIsArray && this.parentOpen;
    },
    nameString() {
      return String(this.name);
    }
  },
  watch: {
    parentOpen(e) {
      e || (this.expanded = !1, this.setOpen(!1, { user: !1 }));
    },
    // make reactive to startClose prop change
    startClosed() {
      this.level === 0 && this.setOpen(!this.startClosed, { user: !1 });
    },
    // opens levels
    openLevel: {
      handler(e) {
        if (this.useOpenLevel = this.openLevel, this.startClosed && this.level === 0 && !this.initializedClosed) {
          this.initializedClosed = !0;
          return;
        }
        if (typeof this.openLevel == "number" && this.openPointer(this.level < this.openLevel), this.getTypeFn(this.openLevel) === "array")
          for (let t = 0; t < this.openLevel.length; t++)
            this.openPointer(this.level === parseInt(this.openLevel[t]));
      },
      immediate: !0
    },
    // opens specific pointers
    unwrapSpecific: {
      handler(e) {
        if (this.openSpecific.length && typeof this.pointer < "u" && this.pointer !== null) {
          let t = this.getAllPointer(this.pointer);
          if (this.pointer in e || t in e) {
            if (this.pointer in this.shared.hiddenPointers)
              return;
            Ne(() => {
              this.$nextTick(() => {
                this.parentIsOpen() && this.setOpen(!0, { user: !1 });
              });
            });
          }
        }
      },
      immediate: !0
    },
    // fires events on open and closing
    isOpen: {
      handler(e, t) {
        if (e)
          this.items = this.makeItems(), this.useOpenLevel = this.openLevel, this.useOpenSpecific = this.openSpecific;
        else {
          const s = () => {
            this.useOpenLevel = 0, this.useOpenSpecific = [];
          };
          this.hideTimes === 0 ? s() : setTimeout(() => s(), 1), this.hideTimes++;
        }
      },
      immediate: !0
    },
    // expand previews
    preview(e) {
      this.expanded = e, this.setOpen(!!(this.isOpen && e), { user: !1 });
    },
    previewInitial() {
      this.expanded = this.allowPreview;
    },
    openSpecific() {
      this.useOpenSpecific = this.openSpecific;
    }
  },
  components: {
    NodePrimitive: ze
  }
}, jt = ["id"], Bt = { class: "vue-dd-start" }, Vt = ["innerHTML"], zt = {
  key: 3,
  class: "vue-dd-colon"
}, Ht = ["innerHTML"], Dt = {
  key: 0,
  class: "vue-dd-comma"
}, Qt = ["innerHTML"], Ut = {
  key: 9,
  class: "vue-dd-instance"
}, Zt = /* @__PURE__ */ L("span", { class: "vue-dd-size-bracket" }, "[", -1), Wt = /* @__PURE__ */ L("span", { class: "vue-dd-size-bracket" }, "]", -1), Kt = { key: 0 }, Gt = { key: 1 }, Xt = { key: 13 }, qt = {
  key: 14,
  class: "vue-dd-forget-cleared"
}, Jt = ["innerHTML"], Yt = {
  key: 1,
  class: "vue-dd-promise-content"
}, $t = /* @__PURE__ */ L("span", { class: "vue-dd-size-bracket" }, "(", -1), en = ["innerHTML"], tn = /* @__PURE__ */ L("span", { class: "vue-dd-size-bracket" }, ")", -1), nn = { key: 3 }, sn = {
  key: 4,
  class: "vue-dd-f-content"
}, rn = { key: 0 }, on = ["innerHTML"], an = {
  key: 0,
  class: "vue-dd-comma"
}, ln = { key: 1 }, cn = ["innerHTML"], un = {
  key: 0,
  class: "vue-dd-comma"
}, dn = {
  key: 5,
  class: "vue-dd-string"
}, hn = { key: 0 }, pn = {
  key: 0,
  class: "vue-dd-comma"
}, gn = { key: 1 }, fn = {
  key: 0,
  class: "vue-dd-comma"
}, mn = ["innerHTML"], yn = ["innerHTML"], vn = {
  key: 8,
  class: "vue-dd-comma"
};
function bn(e, t, s, o, i, n) {
  const a = de("node-primitive"), l = de("node-complex", !0);
  return d(), h("div", {
    id: i.id,
    class: P({ "vue-dd-body": !0, "vue-dd-box-closed": !i.isOpen })
  }, [
    L("div", Bt, [
      s.saveFocus ? (d(), h("span", {
        key: 0,
        ref: "focusElement",
        class: P(["vue-dd-focus vue-dd-icon-eye", {
          "vue-dd-focus-hover": i.hover,
          "vue-dd-focus-selected": n.isFocused
        }]),
        onClick: t[0] || (t[0] = x((...r) => n.focusEmit && n.focusEmit(...r), ["prevent"])),
        onMouseenter: t[1] || (t[1] = (r) => i.hover = !0),
        onMouseup: t[2] || (t[2] = (r) => i.hover = !1),
        onMouseleave: t[3] || (t[3] = (r) => i.hover = !1)
      }, null, 34)) : b("", !0),
      s.arrow ? (d(), h("span", {
        key: 1,
        onClick: t[4] || (t[4] = x((...r) => n.toggleOpen && n.toggleOpen(...r), ["prevent"])),
        class: P(["vue-dd-arrow", { "vue-dd-arrow-collapsed": !i.isOpen }]),
        innerHTML: i.isOpen ? s.arrowOpen : s.arrowClosed
      }, null, 10, Vt)) : b("", !0),
      n.showName ? (d(), h("span", {
        key: 2,
        onClick: t[5] || (t[5] = x((...r) => n.toggleOpen && n.toggleOpen(...r), ["prevent"])),
        onMousedown: t[6] || (t[6] = (r) => n.preventSelect(r)),
        class: P(["vue-dd-name", {
          "vue-dd-f-name": n.isFunction,
          "vue-dd-key-of-array": n.parentIsArray
        }])
      }, j(s.name), 35)) : b("", !0),
      s.level !== 0 ? (d(), h("span", zt, ":")) : b("", !0),
      n.isIterable && n.isReactive ? (d(), h("span", {
        key: 4,
        onClick: t[7] || (t[7] = x((...r) => n.toggleOpen && n.toggleOpen(...r), ["prevent"])),
        onMousedown: t[8] || (t[8] = (r) => n.preventSelect(r)),
        class: "vue-dd-r",
        title: "Reactive"
      }, "R", 32)) : n.isIterable && n.isRef ? (d(), h("span", {
        key: 5,
        onClick: t[9] || (t[9] = x((...r) => n.toggleOpen && n.toggleOpen(...r), ["prevent"])),
        onMousedown: t[10] || (t[10] = (r) => n.preventSelect(r)),
        class: "vue-dd-ref",
        title: "Ref"
      }, "Ref", 32)) : n.isFunction ? (d(), h("span", {
        key: 6,
        onClick: t[11] || (t[11] = x((...r) => n.toggleOpen && n.toggleOpen(...r), ["prevent"])),
        onMousedown: t[12] || (t[12] = (r) => n.preventSelect(r)),
        class: "vue-dd-f",
        title: "Function"
      }, "f", 32)) : b("", !0),
      n.isFunction && i.isOpen ? (d(), h("pre", {
        key: 7,
        onClick: t[13] || (t[13] = x((...r) => n.toggleOpen && n.toggleOpen(...r), ["prevent"])),
        class: "vue-dd-f-start"
      }, [
        L("span", { innerHTML: n.functionName }, null, 8, Ht),
        n.shouldComma && !i.isOpen ? (d(), h("span", Dt, ",")) : b("", !0)
      ])) : b("", !0),
      n.isIterable && i.isOpen ? (d(), h("span", {
        key: 8,
        onClick: t[14] || (t[14] = x((...r) => n.toggleOpen && n.toggleOpen(...r), ["prevent"])),
        onMousedown: t[15] || (t[15] = (r) => n.preventSelect(r)),
        class: P(n.charClass),
        innerHTML: n.charOpen
      }, null, 42, Qt)) : b("", !0),
      n.isIterable && i.isOpen && n.instanceOf ? (d(), h("span", Ut, j(n.instanceOf), 1)) : b("", !0),
      n.isIterable && i.isOpen && i.getSize ? (d(), h("span", {
        key: 10,
        onClick: t[16] || (t[16] = x((...r) => n.toggleOpen && n.toggleOpen(...r), ["prevent"])),
        onMousedown: t[17] || (t[17] = (r) => n.preventSelect(r)),
        class: "vue-dd-size"
      }, [
        Zt,
        ve(j(i.getSize), 1),
        Wt
      ], 32)) : b("", !0),
      n.isIterable && n.isPromise && !i.isOpen ? (d(), h("span", {
        key: 11,
        onClick: t[18] || (t[18] = x((...r) => n.toggleOpen && n.toggleOpen(...r), ["prevent"])),
        onMousedown: t[19] || (t[19] = (r) => n.preventSelect(r)),
        class: "vue-dd-instance vue-dd-promise-prototype"
      }, "Promise", 32)) : b("", !0),
      i.isOpen && s.level === 0 && s.save && !i.cleared ? (d(), h("span", {
        key: 12,
        onClick: t[20] || (t[20] = x((r) => i.askForget = !0, ["prevent"])),
        class: P(["vue-dd-forget vue-dd-forget-q", { "vue-dd-forget-q-ask": i.askForget }])
      }, [
        i.askForget ? (d(), h("span", Kt, "clear save?")) : (d(), h("span", Gt, "forget"))
      ], 2)) : b("", !0),
      i.askForget ? (d(), h("span", Xt, [
        L("span", {
          class: "vue-dd-forget vue-dd-forget-yes",
          onClick: t[21] || (t[21] = x((...r) => n.forget && n.forget(...r), ["prevent"]))
        }, "yes"),
        L("span", {
          class: "vue-dd-forget vue-dd-forget-no",
          onClick: t[22] || (t[22] = x((r) => i.askForget = !1, ["prevent"]))
        }, "no")
      ])) : b("", !0),
      i.cleared ? (d(), h("span", qt, " cleared ")) : b("", !0)
    ]),
    L("div", {
      class: P({
        "vue-dd-box": i.isOpen,
        "vue-dd-box-closed": !i.isOpen,
        "vue-dd-box-complex": !0
      })
    }, [
      L("div", null, [
        n.isIterable && !i.isOpen ? (d(), h("span", {
          key: 0,
          class: P(n.charClass),
          innerHTML: n.charOpen
        }, null, 10, Jt)) : b("", !0),
        n.isIterable && n.isPromise ? (d(), h("span", Yt, "<pending>")) : b("", !0),
        n.isIterable && !i.isOpen && !n.allowPreview ? (d(), h("span", {
          key: 2,
          onClick: t[23] || (t[23] = x((...r) => n.expand && n.expand(...r), ["prevent"])),
          class: "vue-dd-expand"
        }, [
          $t,
          L("span", {
            class: "vue-dd-expand-more",
            innerHTML: s.more
          }, null, 8, en),
          tn
        ])) : b("", !0),
        n.isIterable && (i.isOpen || i.expanded) ? (d(), h("div", nn, [
          (d(!0), h(Ke, null, Ge(i.isOpen ? i.items.length : n.allowPreview < i.items.length ? n.allowPreview : i.items.length, (r) => (d(), h("div", { key: r }, [
            L("div", null, [
              s.isPrimitiveFn(n.getSpecialType(i.items[r - 1])) ? (d(), he(a, {
                key: 0,
                root: s.root,
                rootId: s.rootId,
                modelValue: n.getModelValue(i.items[r - 1]),
                name: i.items[r - 1],
                escapeQuotes: s.escapeQuotes,
                focus: s.focus,
                save: s.save,
                saveFocus: s.saveFocus,
                delimiter: s.delimiter,
                pointer: n.getPointer(i.items[r - 1]),
                parentOpen: i.isOpen,
                type: n.getSpecialType(i.items[r - 1]),
                parentType: s.type,
                size: i.getSize,
                position: r,
                expanded: i.expanded,
                escapeQuotesFn: s.escapeQuotesFn,
                emitFn: s.emitFn,
                onOpenParent: n.openParent
              }, null, 8, ["root", "rootId", "modelValue", "name", "escapeQuotes", "focus", "save", "saveFocus", "delimiter", "pointer", "parentOpen", "type", "parentType", "size", "position", "expanded", "escapeQuotesFn", "emitFn", "onOpenParent"])) : (d(), he(l, {
                key: 1,
                root: s.root,
                rootId: s.rootId,
                modelValue: n.getModelValue(i.items[r - 1]),
                name: i.items[r - 1],
                deep: n.isRef ? !1 : s.deep,
                watch: s.watch,
                preview: i.isOpen ? s.preview : !1,
                getAllProperties: s.getAllProperties,
                openLevel: i.useOpenLevel,
                openSpecific: i.useOpenSpecific,
                startClosed: s.startClosed,
                longText: s.longText,
                escapeQuotes: s.escapeQuotes,
                focus: s.focus,
                save: s.save,
                saveFocus: s.saveFocus,
                delimiter: s.delimiter,
                more: s.more,
                arrow: s.arrow,
                arrowOpen: s.arrowOpen,
                arrowClosed: s.arrowClosed,
                pointer: n.getPointer(i.items[r - 1]),
                parentType: s.type,
                parentOpen: i.isOpen,
                type: n.getSpecialType(i.items[r - 1]),
                shared: s.shared,
                level: s.level + 1,
                size: i.getSize,
                position: r,
                escapeQuotesFn: s.escapeQuotesFn,
                getTypeFn: s.getTypeFn,
                isPrimitiveFn: s.isPrimitiveFn,
                unwrapSpecificFn: s.unwrapSpecificFn,
                emitFn: s.emitFn,
                onOpenParent: n.openParent
              }, null, 8, ["root", "rootId", "modelValue", "name", "deep", "watch", "preview", "getAllProperties", "openLevel", "openSpecific", "startClosed", "longText", "escapeQuotes", "focus", "save", "saveFocus", "delimiter", "more", "arrow", "arrowOpen", "arrowClosed", "pointer", "parentType", "parentOpen", "type", "shared", "level", "size", "position", "escapeQuotesFn", "getTypeFn", "isPrimitiveFn", "unwrapSpecificFn", "emitFn", "onOpenParent"]))
            ])
          ]))), 128))
        ])) : b("", !0),
        n.isFunction ? (d(), h("div", sn, [
          i.isOpen && n.functionContent ? (d(), h("pre", rn, [
            L("span", { innerHTML: n.functionContent }, null, 8, on),
            n.shouldComma ? (d(), h("span", an, ",")) : b("", !0)
          ])) : i.isOpen && !n.functionContent ? (d(), h("span", ln)) : (d(), h("span", {
            key: 2,
            onClick: t[24] || (t[24] = x((...r) => n.toggleOpen && n.toggleOpen(...r), ["prevent"])),
            class: "vue-dd-f-inline"
          }, [
            L("span", {
              innerHTML: n.allowPreview ? n.functionInlinePreview : n.functionInline
            }, null, 8, cn),
            n.shouldComma ? (d(), h("span", un, ",")) : b("", !0)
          ]))
        ])) : b("", !0),
        n.isLongText ? (d(), h("div", dn, [
          i.isOpen ? (d(), h("span", hn, [
            ve(j(n.longTextContent), 1),
            n.shouldComma ? (d(), h("span", pn, ",")) : b("", !0)
          ])) : (d(), h("span", gn, [
            ve(j(n.longTextInline), 1),
            n.shouldComma ? (d(), h("span", fn, ",")) : b("", !0)
          ]))
        ])) : b("", !0),
        n.isIterable && !i.isOpen && n.allowPreview && s.preview < i.items.length ? (d(), h("span", {
          key: 6,
          onClick: t[25] || (t[25] = x((...r) => n.expand && n.expand(...r), ["prevent"])),
          class: "vue-dd-expand",
          innerHTML: s.more
        }, null, 8, mn)) : b("", !0),
        n.isIterable ? (d(), h("span", {
          key: 7,
          class: P(n.charClass),
          innerHTML: n.charClose
        }, null, 10, yn)) : b("", !0),
        n.isIterable && n.shouldComma ? (d(), h("span", vn, ",")) : b("", !0)
      ])
    ], 2)
  ], 10, jt);
}
const wn = /* @__PURE__ */ pe(Pt, [["render", bn]]);
let Se = {};
const Sn = Xe({
  name: "VueDd",
  inheritAttrs: !1,
  emits: ["open", "toggle", "focus", "show"],
  props: {
    // main options
    modelValue: { type: void 0, required: !0 },
    id: { type: [String, Number], default: "" },
    name: { type: String, default: "" },
    getAllProperties: { type: Boolean, default: !1 },
    openLevel: { type: [Number, String, Array], default: 0 },
    openSpecific: { type: Array, default: () => [] },
    startClosed: { type: Boolean, default: !1 },
    focus: { type: [String, Number], default: null },
    focusSticky: { type: Boolean, default: !1 },
    focusOffsetX: { type: Number, default: -35 },
    focusOffsetY: { type: Number, default: -15 },
    focusDelay: { type: Number, default: 150 },
    preview: { type: [Number, Boolean], default: 5 },
    previewInitial: { type: Boolean, default: !0 },
    escapeQuotes: { type: Boolean, default: !1 },
    longText: { type: Number, default: 50 },
    delimiter: { type: String, default: "." },
    more: { type: String, default: "..." },
    // styling options
    arrow: { type: Boolean, default: !0 },
    arrowOpen: { type: String, default: "&#x25BC;" },
    arrowClosed: { type: String, default: "&#x25BC;" },
    inline: { type: Boolean, default: !0 },
    dark: { type: Boolean, default: !0 },
    fontFamily: { type: String, default: '"JetBrains Mono", "Courier", serif' },
    fontSize: { type: String, default: ".7rem" },
    lineHeight: { type: String, default: "1rem" },
    paddingLeft: { type: String, default: ".7rem" },
    maxHeight: { type: String, default: "500px" },
    maxWidth: { type: String, default: "100%" },
    // save
    save: { type: Boolean, default: !1 },
    saveFocus: { type: Boolean, default: !0 },
    storage: { type: String, default: "local" },
    // session | local
    // watch options
    watch: { type: Boolean, default: !0 },
    deep: { type: Boolean, default: !0 }
  },
  data() {
    return {
      rootId: dt(this.id, this.name, window),
      openClass: !1,
      css: this.class,
      useOpenSpecific: this.openSpecific,
      // if openLevel is string, convert to number int
      memory: null,
      shared: {
        hiddenPointers: {}
        // must be defined as empty
      },
      setFocusAlready: !1,
      useFocus: null,
      // saveFocus only works, if you supply an id or a name for the object
      useSaveFocus: !this.id && !this.name ? !1 : this.saveFocus
    };
  },
  created() {
    (this.save || this.useSaveFocus) && this.initMemory(), this.useFocus = this.getFocus(), this.useOpenSpecific = this.getOpenSpecific();
  },
  mounted() {
  },
  computed: {
    useOpenLevel() {
      return typeof this.openLevel == "string" ? parseInt(this.openLevel) : this.openLevel;
    },
    cssVars() {
      return {
        "--vue-dd-fontFamily": this.fontFamily,
        "--vue-dd-fontSize": this.fontSize,
        "--vue-dd-lineHeight": this.lineHeight,
        "--vue-dd-paddingLeft": this.paddingLeft,
        "--vue-dd-maxHeight": this.maxHeight,
        "--vue-dd-maxWidth": this.maxWidth
      };
    },
    unwrapSpecific() {
      return this.unwrapSpecificFn(this.openSpecific);
    },
    type() {
      return this.getTypeFn(this.modelValue);
    },
    primitive() {
      return this.isPrimitiveFn(this.type);
    },
    isSet() {
      return this.type === "object" && this.modelValue instanceof Set;
    },
    isRef() {
      return Ve(this.modelValue);
    }
  },
  methods: {
    forgetEmit() {
      this.save && typeof this.memory == "object" && (this.memory.open = {}, this.shared.hiddenPointers = {}, this.useOpenSpecific = this.baseOpenSpecific(), this.store().set(this.memory));
    },
    setFocus() {
      if (this.useSaveFocus && this.useFocus !== null) {
        let e = !0;
        this.setFocusAlready && (e = !1), this.focusSticky && (e = !0), e && setTimeout(() => {
          const t = this.getElement(this.useFocus);
          t && (this.$refs.root.scrollLeft = t.offsetLeft + this.focusOffsetX, this.$refs.root.scrollTop = t.offsetTop + this.focusOffsetY, t.classList.add("vue-dd-highlight"), setTimeout(() => t.classList.remove("vue-dd-highlight"), 500), this.setFocusAlready = !0);
        }, this.focusDelay);
      }
    },
    getElement(e) {
      e = e === "" ? "" : `${this.delimiter}${e}`;
      const t = `_${this.rootId}${e}`;
      return document.getElementById(t);
    },
    getFocus() {
      let e = this.focus;
      return this.useSaveFocus && "focus" in this.memory && this.memory.focus !== null && (e = String(this.memory.focus)), e;
    },
    initMemory() {
      this.memory = this.store().get(), Ie(this.memory) || (this.memory = {}), (!("open" in this.memory) || !Ie(this.memory.open)) && (this.memory.open = {}), "focus" in this.memory || (this.memory.focus = null);
    },
    getOpenSpecific() {
      if (this.save) {
        this.memory.open = { ...this.memory.open, ...this.unwrapSpecific }, this.store().set(this.memory);
        let e = [];
        for (let t in this.memory.open)
          e.push(String(t));
        return e;
      } else
        return this.baseOpenSpecific();
    },
    baseOpenSpecific() {
      return [...this.openSpecific, ...this.useFocus === null ? [] : [String(this.useFocus)]];
    },
    focusEmit(e) {
      let { pointer: t, focusElement: s } = e;
      if (this.useSaveFocus) {
        const o = this.useFocus;
        if (String(t) === String(o) && String(t) !== String(this.focus)) {
          if (this.openSpecific.indexOf(t) === -1) {
            const i = this.useOpenSpecific.indexOf(t);
            i > -1 && this.useOpenSpecific.splice(i, 1);
          }
          delete this.memory.open[t], t = null, s.classList.remove("vue-dd-focus-selected");
        } else {
          if (this.openSpecific.indexOf(o) === -1) {
            const n = this.useOpenSpecific.indexOf(o);
            n > -1 && this.useOpenSpecific.splice(n, 1);
          }
          delete this.memory.open[o];
          const i = this.getElement(o);
          if (i) {
            const n = i.querySelector(".vue-dd-focus");
            n && n.classList.remove("vue-dd-focus-selected");
          }
          s.classList.add("vue-dd-focus-selected");
        }
        this.memory.focus = t === null ? this.focus : t, this.useOpenSpecific.push(this.memory.focus), this.store().set(this.memory), this.useFocus = this.memory.focus, this.emitFn(this, "focus", { focus: this.memory.focus, focusElement: s });
      }
    },
    showEmit(e) {
      let { type: t, pointer: s, focusElement: o } = e;
      this.emitFn(this, "show", e), this.useSaveFocus && this.useFocus === s && this.setFocus();
    },
    openEmit(e) {
      const { isOpen: t, pointer: s, level: o, user: i } = e;
      o === 0 && (this.startClosed && t && this.useOpenSpecific.indexOf("") === -1 && this.useOpenSpecific.push(""), this.openClass = t), this.$emit("open", e);
    },
    toggleEmit(e) {
      const { event: t, isOpen: s, pointer: o, level: i } = e;
      if (this.save) {
        const n = o in this.unwrapSpecific;
        if (s)
          delete this.shared.hiddenPointers[o], n || this.useOpenSpecific.push(o), this.memory.open[o] = !0;
        else {
          if (this.shared.hiddenPointers[o] = !0, n) {
            const a = this.useOpenSpecific.indexOf(o);
            a >= 0 && delete this.useOpenSpecific[a];
          }
          delete this.memory.open[o];
        }
        this.store().set(this.memory);
      }
      this.$emit("toggle", e);
    },
    store() {
      const e = "vue-dd." + this.rootId;
      return {
        get: () => {
          try {
            return JSON.parse(window[`${this.storage}Storage`].getItem(e));
          } catch {
          }
        },
        set: (t) => window[`${this.storage}Storage`].setItem(e, JSON.stringify(t))
      };
    },
    getTypeFn(e) {
      let t = typeof e;
      return t === "object" ? e === null ? "null" : Array.isArray(e) ? "array" : "object" : (t === "string" && e.length > this.longText && (t = "longtext"), t === "function" && this.getAllProperties && e.toString()[0] === "c" && (t = "class"), t);
    },
    isPrimitiveFn(e) {
      return !(e === "array" || e === "object" || e === "function" || e === "longtext" || e === "class");
    },
    escapeQuotesFn(e) {
      return this.escapeQuotes ? e.replaceAll('"', '\\"') : e;
    },
    unwrapSpecificFn(e) {
      let t = {};
      if (e.length) {
        const s = e;
        if (s in Se)
          return Se[s];
        e.forEach((o) => {
          const i = String(o).split(this.delimiter);
          let n = "", a = 0;
          for (let l in i)
            n += (a > 0 ? this.delimiter : "") + i[l], t[n] = !0, a++;
          a > 0 && (t[""] = !0);
        }), this.useFocus !== null && (t[this.useFocus] = !0), this.startClosed && "" in t && delete t[""], Se[s] = t;
      }
      return t;
    },
    // recursive emit
    // more info: https://stackoverflow.com/a/55650245/1502706
    emitFn(e, t, ...s) {
      for (; e && !(e.$options.name !== "VueDd" && e.$options.name !== "NodeComplex" && e.$options.name !== "NodePrimitive"); )
        e.$emit(t, ...s), e = e.$parent;
    },
    open() {
      this.$refs.nodeComplex.open();
    },
    close() {
      this.$refs.nodeComplex.close();
    },
    toggle() {
      this.$refs.nodeComplex.toggle();
    }
  },
  watch: {
    modelValue: {
      handler(e, t) {
        this.focusSticky && e !== t && this.setFocus();
      }
    },
    openSpecific() {
      this.useOpenSpecific = this.getOpenSpecific();
    },
    save() {
      this.useOpenSpecific = this.getOpenSpecific();
    }
  },
  components: {
    NodeComplex: wn,
    NodePrimitive: ze
  }
});
const On = ["id"];
function kn(e, t, s, o, i, n) {
  const a = de("node-primitive"), l = de("node-complex");
  return d(), h("div", {
    ref: "root",
    id: e.rootId,
    class: P(["vue-dd", {
      "vue-dd-inline": e.inline,
      "vue-dd-open": e.openClass,
      "vue-dd-dark": e.dark,
      "vue-dd-no-arrow": !e.arrow
    }, e.$attrs.class]),
    style: qe([e.cssVars, e.$attrs.style])
  }, [
    e.primitive ? (d(), he(a, {
      key: 0,
      root: e.$refs.root,
      rootId: e.rootId,
      modelValue: e.modelValue,
      name: e.name,
      focus: e.useFocus,
      escapeQuotes: e.escapeQuotes,
      save: e.save,
      saveFocus: e.useSaveFocus,
      delimiter: e.delimiter,
      pointer: "",
      type: e.type,
      parentOpen: !1,
      parentType: "",
      escapeQuotesFn: e.escapeQuotesFn,
      emitFn: e.emitFn,
      onFocus: e.focusEmit,
      onShow: e.showEmit
    }, null, 8, ["root", "rootId", "modelValue", "name", "focus", "escapeQuotes", "save", "saveFocus", "delimiter", "type", "escapeQuotesFn", "emitFn", "onFocus", "onShow"])) : (d(), he(l, {
      key: 1,
      ref: "nodeComplex",
      root: e.$refs.root,
      rootId: e.rootId,
      modelValue: e.modelValue,
      name: e.name,
      getAllProperties: e.getAllProperties,
      openLevel: e.useOpenLevel,
      openSpecific: e.useOpenSpecific,
      focus: e.useFocus,
      escapeQuotes: e.escapeQuotes,
      startClosed: e.startClosed,
      longText: e.longText,
      preview: e.preview,
      previewInitial: e.previewInitial,
      deep: e.isRef ? !0 : e.deep,
      watch: e.watch,
      save: e.save,
      saveFocus: e.useSaveFocus,
      arrow: e.arrow,
      arrowOpen: e.arrowOpen,
      arrowClosed: e.arrowClosed,
      delimiter: e.delimiter,
      more: e.more,
      pointer: "",
      type: e.type,
      parentType: "",
      parentOpen: !1,
      shared: e.shared,
      getTypeFn: e.getTypeFn,
      isPrimitiveFn: e.isPrimitiveFn,
      escapeQuotesFn: e.escapeQuotesFn,
      unwrapSpecificFn: e.unwrapSpecificFn,
      emitFn: e.emitFn,
      onShow: e.showEmit,
      onToggle: e.toggleEmit,
      onOpen: e.openEmit,
      onFocus: e.focusEmit,
      onForget: e.forgetEmit
    }, null, 8, ["root", "rootId", "modelValue", "name", "getAllProperties", "openLevel", "openSpecific", "focus", "escapeQuotes", "startClosed", "longText", "preview", "previewInitial", "deep", "watch", "save", "saveFocus", "arrow", "arrowOpen", "arrowClosed", "delimiter", "more", "type", "shared", "getTypeFn", "isPrimitiveFn", "escapeQuotesFn", "unwrapSpecificFn", "emitFn", "onShow", "onToggle", "onOpen", "onFocus", "onForget"]))
  ], 14, On);
}
const En = /* @__PURE__ */ pe(Sn, [["render", kn]]), Fn = {};
function _n(e, t) {
  return d(), h("div", null, "Hello world");
}
const An = /* @__PURE__ */ pe(Fn, [["render", _n]]);
function Nn(e) {
  e.component("VueDd", En), e.component("XRay", An);
}
export {
  En as VueDd,
  An as XRay,
  Nn as install
};
